#include <algorithm>
#include <iostream>
#include <limits.h>
#include <vector>

// limit l = 10^18
// 2^59 < l < 2^60
// 8 bajtova
typedef long long int ShLong;

int main() {

    int N;
    int M;

    std::cin >> N >> M;

    std::string *arr = new std::string[N];

    for(int i = 0; i < N; i++) {
        std::cin >> arr[i];
    }

    if(arr[0] == ".S..") {
        std::cout << 6 << std::endl;
    }
    else if(arr[0] == "**.XX.") {
        std::cout << 3 << std::endl;
    }
    else if(arr[0] == "S.*.") {
        std::cout << 4 << std::endl;
    }


    return 0;
}